// This is the main DLL file.

#using "AnalCSharp.dll"

#include "stdafx.h"
#include "CppWrapper.h"
#include <msclr\auto_gcroot.h>

using namespace System::Runtime::InteropServices; // Marshal

class CppWrapperPrivate
{
public: msclr::auto_gcroot<AnalCSharp^> csharp;
};

CppWrapper::CppWrapper()
{
	_private = new CppWrapperPrivate();
	_private->csharp = gcnew AnalCSharp();
}

void CppWrapper::CppWCSComms(char* OpenFileName, char* SaveFileName, long* int_vec, long* iSheetName, long* RowStart, long* ColStart, long* RowNumb, long* ColNumb, double* xx)
{

	// copy unmanaged character variables to managed variables
	System::String^ _OpenFileName = gcnew System::String(OpenFileName);
	System::String^ _SaveFileName = gcnew System::String(SaveFileName);

	// copy unmanaged integer array to managed array
	array<__int32>^ _int_vec = gcnew array<__int32>(4);
	Marshal::Copy(System::IntPtr((void *)int_vec), _int_vec, 0, 4);

	// copy unmanaged integer array to managed array
	int temp1 = int_vec[0] * 256;
	array<__int32>^ _iSheetName = gcnew array<__int32>(temp1);
	Marshal::Copy(System::IntPtr((void *)iSheetName), _iSheetName, 0, temp1);

	// copy unmanaged integer array to managed array
	int temp2 = int_vec[0];
	array<__int32>^ _RowStart = gcnew array<__int32>(temp2);
	Marshal::Copy(System::IntPtr((void *)RowStart), _RowStart, 0, temp2);

	array<__int32>^ _ColStart = gcnew array<__int32>(temp2);
	Marshal::Copy(System::IntPtr((void *)ColStart), _ColStart, 0, temp2);

	array<__int32>^ _RowNumb = gcnew array<__int32>(temp2);
	Marshal::Copy(System::IntPtr((void *)RowNumb), _RowNumb, 0, temp2);

	array<__int32>^ _ColNumb = gcnew array<__int32>(temp2);
	Marshal::Copy(System::IntPtr((void *)ColNumb), _ColNumb, 0, temp2);

	// copy unmanaged real array to managed array
	int temp3 = int_vec[0] * int_vec[1] * int_vec[2];
	array<double>^ _xx = gcnew array<double>(temp3);
	Marshal::Copy(System::IntPtr((void *)xx), _xx, 0, temp3);

	// run C# routine
	_private->csharp->CSExcelComms(_OpenFileName, _SaveFileName, _int_vec, _iSheetName, _RowStart, _ColStart, _RowNumb, _ColNumb, _xx);

	// if read, then recover managed array to unmanaged array
	if (int_vec[3] == 1) Marshal::Copy(_xx, 0, System::IntPtr((void *)xx), temp3);

	// exit wrapper
	return;
}


void CppWrapper::CppWCSJobFileRepn(char* RootSimName, char* DirName, long* int_vec)
{

	// copy unmanaged character variables to managed variables
	System::String^ _DirName = gcnew System::String(DirName);
	System::String^ _RootSimName = gcnew System::String(RootSimName);

	// copy unmanaged integer array to managed array
	array<__int32>^ _int_vec = gcnew array<__int32>(3);
	Marshal::Copy(System::IntPtr((void *)int_vec), _int_vec, 0, 3);

	// run C# routine
	_private->csharp->CSJobFileRepn(_RootSimName, _DirName, _int_vec);

	// exit wrapper
	return;
}



CppWrapper::~CppWrapper()
{
	delete _private;
}

/*

For details about copying data between managed and unmanaged code, see:
https://msdn.microsoft.com/en-us/library/system.runtime.interopservices.marshal_methods(v=vs.110).aspx

Structure of approach based on: http://pragmateek.com/using-c-from-native-c-with-the-help-of-ccli-v2/
System::String is not meant to be CLI compliant, and this may result in errors in the future.

*/
