!  analysis.f90 
!
!  FUNCTIONS:
!  analysis - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: analysis - program to manage secondary analyses
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************

program analysis

USE internal_analyses

implicit none


! Variables
integer(4) :: flag_repsum, flag_decagg, flag_jobfilerep
character(2000) :: OutDir
character(256) :: RootSimName, AnalFile
integer(4) :: SimNumb, SimStart, StartAge, mm, nn, nn_t, nn_ab
integer(4) :: NoReps, StartNo, StartIndex, decile_flag(10)
integer(4), allocatable :: age_bands(:)


!********************************************************************
!	begin code
!********************************************************************


!********************************************************************
!	Routine to replicate job file for cloned analysis
!********************************************************************
!NoReps = 10		! number of replications to generate
!StartIndex = 0	! index of simulation name
!
!StartNo = 1		! Job NameXX
!RootSimName = 'Job Filea.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)
!
!StartNo = 11	! Job NameXX
!RootSimName = 'Job Fileb.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)
!
!StartNo = 21	! Job NameXX
!RootSimName = 'Job Filec.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)
!
!StartNo = 31	! Job NameXX
!RootSimName = 'Job Filed.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)
!
!StartNo = 41	! Job NameXX
!RootSimName = 'Job Filee.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)
!
!StartNo = 51	! Job NameXX
!RootSimName = 'Job Filef.xls'
!call JobFileReplicate(RootSimName, NoReps, StartNo, StartIndex)


!********************************************************************
!	Routines to analyse cloned statistics
!********************************************************************
!mm = 42			! number of rows in decile analysis
!nn = 4			! number of columns in decile analysis
!SimNumb = 30	! number of simulation replications
!SimStart = 0	! starting number of simulated replications
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2016'
!AnalFile = 'hi_level_stats_diff2016.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2021'
!AnalFile = 'hi_level_stats_diff2021.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2026'
!AnalFile = 'hi_level_stats_diff2026.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2036'
!AnalFile = 'hi_level_stats_diff2036.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2046'
!AnalFile = 'hi_level_stats_diff2046.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'rbm20_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_1_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!RootSimName = 'trp10_2_'
!call ReplicnSummary2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)


!********************************************************************
!	re-package cloned statistics
!********************************************************************
!RootSimName = "trp10_"
!call BespokeAnalysis(RootSimName)
!
!RootSimName = "rbm20_"
!call BespokeAnalysis(RootSimName)


!********************************************************************
!	Scatter plot cloned statistics
!********************************************************************
!mm = 42			! number of rows in decile analysis
!nn = 4			! number of columns in decile analysis
!nn_t = 4		! column number of target statistics
!SimNumb = 30	! number of simulation replications
!SimStart = 0	! starting number of simulated replications
!
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2016'
!AnalFile = 'hi_level_stats_diff2016.csv'
!
!RootSimName = 'trp10_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!RootSimName = 'rbm20_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2021'
!AnalFile = 'hi_level_stats_diff2021.csv'
!
!RootSimName = 'trp10_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!RootSimName = 'rbm20_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2026'
!AnalFile = 'hi_level_stats_diff2026.csv'
!
!RootSimName = 'trp10_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!RootSimName = 'rbm20_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2036'
!AnalFile = 'hi_level_stats_diff2036.csv'
!
!RootSimName = 'trp10_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!RootSimName = 'rbm20_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cross_sections\2046'
!AnalFile = 'hi_level_stats_diff2046.csv'
!
!RootSimName = 'trp10_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'trp10_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!
!RootSimName = 'rbm20_0_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_1_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)
!RootSimName = 'rbm20_2_'
!call ReplicnConsol(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn, nn_t)


!********************************************************************
!	Routines to aggregate and analyse cloned decile statistics
!********************************************************************
!mm = 130 - 17	! number of rows in decile analysis
!nn = 181		! number of columns in decile analysis
!SimNumb = 30	! number of simulation replications
!SimStart = 0	! starting number of simulated replications
!OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cohort_deciles\csv output'
!AnalFile = 'analysis_dec2.csv'
!
!RootSimName = 'rbm20_0_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'rbm20_1_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'rbm20_2_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_0_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_1_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!
!RootSimName = 'trp10_2_'
!call ReplicnSummary(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)
!call DecileAggregn(OutDir, RootSimName, AnalFile, SimNumb, SimStart, mm, nn)


!********************************************************************
!	Routines to aggregate and analyse cloned decile statistics
!********************************************************************
mm = 130 - 17	! number of rows in decile analysis
nn = 181		! number of columns in decile analysis
SimNumb = 30	! number of simulation replications
SimStart = 0	! starting number of simulated replications
OutDir = 'C:\MyFiles\03 PROJECTS\2017\endog savings\01 analysis\summary stats\cohort_deciles\csv output\age_groups\higher2_deciles'
AnalFile = 'analysis_dec2.csv'
decile_flag = 0
decile_flag(9) = 1
decile_flag(10) = 1
StartAge = 18
nn_ab = 6
allocate( age_bands(nn_ab) )
age_bands(1) = 24
age_bands(2) = 44
age_bands(3) = 54
age_bands(4) = 64
age_bands(5) = 74
age_bands(6) = 84

RootSimName = 'trp10_0_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)
RootSimName = 'trp10_1_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)
RootSimName = 'trp10_2_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)
RootSimName = 'rbm20_0_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)
RootSimName = 'rbm20_1_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)
RootSimName = 'rbm20_2_'
call DecileAggregn2(OutDir, RootSimName, AnalFile, SimNumb, SimStart, StartAge, mm, nn, age_bands, nn_ab, decile_flag)

deallocate( age_bands )


!********************************************************************
!	complete analysis
!********************************************************************
print *, 'All requested analyses complete'
pause ' press enter to exit'
stop

end program analysis

